#include <cstdio>
#include "thing.hh"

class Mama : public Thing
{
public:
	Mama()
	{
		std::printf(" Mama comes.\n");
	}
	virtual ~Mama()
	{
		std::printf(" Mama goes.\n");
	}
	virtual void Wave()
	{
		std::printf(" Mama waves.\n");
	}
};

class Baby : public Thing
{
public:
	Baby()
	{
		std::printf("  Baby comes.\n");
	}
	virtual ~Baby()
	{
		std::printf("  Baby goes.\n");
	}
	virtual void Wave()
	{
		std::printf("  Baby waves its hand happily.\n");
	}
};

#include "dynlib.hh"

static void *newmama(void) { return new Mama; }
static void *newbaby(void) { return new Baby; }

dyncontent contents[] =
{
	{ BASETYPE_THING, "Mama", newmama },
	{ BASETYPE_THING, "Baby", newbaby },
	
	{ 0, NULL, NULL }
};
